module Pervasives
  VERSION = "1.1.0"
  def self.version() VERSION end

  Methods = Hash.new{|h,k| h[k] = {}}

  [Class, Module, Object].each do |type|
    type.instance_methods.each do |m|
      Methods[type]["#{ m }"] = type.instance_method m
    end
  end

  def self.call o, m, *a, &b
    list = 
      case o
        when Class then [Class, Module, Object]
        when Module then [Module, Object]
        when Object then [Object]
      end
    type = list.detect{|type| Methods[type]["#{ m }"]} 
    m = Methods[type]["#{ m }"]
    ( m ).bind( o ).call( *a, &b )
  end

  class ::Object
    def __pervasive__ m, *a, &b
      Pervasives.call self, m, *a, &b
    end
  end

  class Proxy
    instance_methods.each{|m| undef_method m unless m[%r/__/]}

    def initialize obj
      @obj = obj
    end

    def method_missing m, *a, &b
      Pervasives.call @obj, m, *a, &b
    end
  end

  def self.new *a, &b
    Proxy.new *a, &b
  end

  class ::Object
    def Pervasives *a, &b
      Proxy.new *a, &b
    end
  end
end
